/*
Murasaki - multiple genome global alignment program
Copyright (C) 2006-2007 Keio University
(Kris Popendorf) <comp@bio.keio.ac.jp> (2006)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/////////////////////
// murasaki config options manager
////////////////////

#ifndef __OPTIONS_H
#define __OPTIONS_H

#include <string>
#include <iostream>

using namespace std;

enum HashType {ArrayHash_t, MSetHash_t, MySQLHash_t, SQLiteHash_t, Last_t};
extern int mpi_id;

class Options {
 public:
  //config options
  int quick_hash;
  int hitfilter;
  int histogram;
  bool user_seed;
  int rand_seed;
  bool repeatMask;
  bool skip1to1,skipFwd,skipRev;
  bool doubleHash;
  bool hashOnly;
  bool hashCache;
  bool bitscore;
  HashType hashPref;
  string alignment_name;
  string output_dir;
  string config_file;
  string cache_dir;

  //computed dynamically in solidfy()
  string prefix;
  string hashStatus_record;
  string hashHisto_record;
  string hashDetailed_record;
  string seq_record;
  string anchor_record;
  string pat_record;
  string region_record;
  string status_record;
  string options_record;

  int seedfilter,hashfilter;

  //functions
  Options();
  void loadConfig(string config);
  void solidify();
  void commandline_opts(int argc,char **argv);
  string hashPref_s() const;
  friend ostream& operator<<(ostream& os,const Options &a);
};

string program_help();

#endif
